%http://rohr.aiax.de/BasicAberrationsandOpticalTesting.pdf
%page 21
N = 5.6;
W040 = 0.35;                            %SA, wavelengths
W020 = -0.35*1.5;                            %Defocus for CLC, wavelengths
lambda = 0.535;                         %um
pitch = 5;                              %um
lambdaN = lambda*N;                     %um

r = 0:lambdaN/16:64*lambdaN;          %um
fun = @(rho) exp(1i*2*pi * (W040*rho^4 + W020*rho^2)) * ...
        besselj(0, pi*r/lambdaN * rho) * rho;
I = pi*(pitch/lambdaN)^2 * abs(integral(fun,0,1,'ArrayValued',true)).^2;
I = I / I(1);

f = 0:1/64:2-1/64;                      %cycles/px
v = f / pitch;                          %cycles/um
s = v * lambdaN;                        %cycles/extinction
i = 1;
MTFSAdef = zeros(size(f));
for rho = v                             %cycles/um
    fun = I .* besselj(0, 2*pi*r .* rho) .* r;
    MTFSAdef(i) = abs(2*pi*trapz(fun,r));
    i = i + 1;
end
MTFSAdef = MTFSAdef / MTFSAdef(1);
MTFdiff = 2./pi.*(acos(s)-s.*sqrt(1-s.^2));

% figure; plot(f,MTFSAdef)
% set(gcf,'WindowStyle','docked');
% hold on; plot(f,MTFdiff)
% grid; title('MTF SA+Defocus: Circularly Symmetric Radial Slice');
% xlabel('c/p'); ylabel('MTF'); axis([0 2 0 1])

% figure; plot(r,I)
% set(gcf,'WindowStyle','docked')
% grid; title('PSF: Circularly Symmetric Radial Slice')
% xlabel('um'); ylabel('Relative Intensity'); xlim([0 40])
%https://www.researchgate.net/post/How_I_can_construct_circularly_symmetric_matrix_from_a_given_vector_in_MATLAB